#ifndef READ_INPUT_AND_MAKE_MATRICIES_H
#define READ_INPUT_AND_MAKE_MATRICIES_H

#include "application.h"

void readTimFileAndPreProcess(ifstream& inStream, bool legacyTim);
//Reads the .tim file (either ITC2007 format, or earlier ITC2002 version) and constructs the 
//data stuctures used by the algorithm

int* makeRoomSizeMatrix(ifstream& i_stream);
//Reads the input file and creates a 1D dynamic array of room sizes

bool** makeAttendsMatrix(ifstream& i_stream);
//Makes a 2D dynamic array the attends matrix

bool** makeRoomFeaturesMatrix(ifstream& i_stream);
//Makes the room features matrix

bool** makeEventFeaturesMatrix(ifstream& i_stream);
//Makes the event_features matrix

bool** makeEventAvail(ifstream& i_stream, bool legacyTim);
//Makes the eventAvail Matrix (NEW PROCEDURE THIS...)

bool** makeRoomAvail(ifstream& inStream, bool legacyTim);
//Makes the rmAvail Matrix (NEW PROCEDURE THIS...)

void makeEventSizeMatrix();
//Calculates and constructs the event size 1D dynamic array

void makeEventRoomMatrix();
//Calculates the event_room matrix

void makeEventConflictMatrix();
//Calculates the event_conflict matrix

void modifyForTightRooms();
//Modifies the event_conflicts matrix by adding edges between events that are preassigned to
//the same one room (as obviously these cannot be placed into the same timeslot

void modiyForDifferentPreAssignments();
//Modifies the conflicts matrix by adding edges between events that have been assigned to
//diferent groups of slots

void makeTotalNumConflict();
//This procedure takes the conflicts matrix and compresses the information into one
//column. So we can then idenify that e.g. event 6 conflicts with 8 events, and e.g.
//event 21 conflicts with 30 events. This might hint therefore that we might want
//to place event 21 first as i is more difficult.

void makePrecidence();
//Makes Precidence list Vector thing (i.e. a compressed version of the before matrix)
//Also updates precidence and before matrix usuing the fact that the before replationship is transitive
//i.e. IF (a -> b) and (b -> c) then (a -> c)   , where "->" means "should come before"
void modifyConflictsForPrecidence();

int** makeBeforeMatrix(ifstream &i_stream, bool legacyTim);
//Makes the "before" matrix, specifying the precidence relations

bool** makeEventPlaceMatrix();

int* makeTotalNumPlaces();

void makeEventStus();

void freeUpHeap();
//Deletes all of the matricies therefore freeing up the heap

int tightRoom(int row);
//Returns the room number of an event that is tight (i.e that can only be scheduled in one room
bool tight(int row);
//Returns true if an event is tight (i.e. can only be scheduled in one room.

#endif //READ_INPUT_AND_MAKE_MATRICIES
