#include "sa-intermediaryfunctions.h"

extern int *roomSize, *eventSize, *totalNumConflict, **before, *originalTotalNumPlaces;
extern bool **attends, **roomFeatures, **eventRoom, **conflict, **eventFeatures, **originalEventPlace, **eventAvail, **roomAvail, *hasPrecConstr;
extern int numEvents, numRooms, numFeatures, numStudents, NUMBEROFPLACES;
extern bool outputOn;
extern TwoDIntVector precidence, beforePrec, feasRooms, eventStus;

//-------------------------------------------------------------------------------------
void makeStuDayCosts(bool **studentavailability, int **stuDayCosts){
	//set up the array.
	int day, theStudent;
	//Using the sAvailMatrix, fill each cell with an appropriate value
	for(day = 0; day<NUMDAYS; day++){
		for(theStudent = 0; theStudent<numStudents; theStudent++){
			int r, longintensive = 0, single = 0, lastslot = 0, licount = 0, scount = 0;
			for (r=day*SLOTSPERDAY; r<(day*SLOTSPERDAY)+SLOTSPERDAY; r++){
				if (!studentavailability[r][theStudent])
					licount++;
				else licount = 0;
				if (licount>=3)
					longintensive++;
				if (!studentavailability[r][theStudent])
					scount++;
			}
			if (scount == 1) 
				single++;
			if (!studentavailability[(day*SLOTSPERDAY)+LASTSLOTINDEX][theStudent]) 
				lastslot++;
			stuDayCosts[day][theStudent] = (longintensive+lastslot+single);
		}
	}
}

//------------------------------------------------------------------------------------
int totalStuCosts(int **stuDayCosts){
	int r, c, total = 0;
	for(r=0; r<NUMDAYS; r++) for(c=0;c<numStudents;c++) total = total+stuDayCosts[r][c];
	return(total);
}

//------------------------------------------------------------------------------------
void fillDayCosts(int **stuDayCosts, int *dayCosts){
	int r, c;
	for(r=0; r<NUMDAYS; r++){
		int dayTotal = 0;
		for(c=0; c<numStudents; c++)
			dayTotal = dayTotal + stuDayCosts[r][c];
		dayCosts[r] = dayTotal;
	}
}

//------------------------------------------------------------------------------------
void makeSAvailFromSol(TTAndUnplaced &theSolution, bool **studentavailability)
{
	int i, r, c;
	for (r=0;r<NUMBEROFSLOTS;r++) for (c=0;c<numStudents;c++) studentavailability[r][c] = true;
	//Now construct the studentavailability from the info. in the solution
	for (r=0;r<numRooms;r++){
		for (c=0; c<NUMBEROFSLOTS; c++){
			if (theSolution.TT[r][c] != -1){
				//Mark a false every student that attends this event in the relevant slot
				for (i=0; i<numStudents; i++){
					if (attends[i][theSolution.TT[r][c]]) studentavailability[c][i] = false;
				}
			}
		}
	}
}

